import 'dart:io';

class Routing {
  Map<String, Function> routes = Map();
  
  Routing(HttpServer server){
    handleRequests(server);
  }

  handleRequests(server) async{
    await for (HttpRequest req in server) {
      req.response.headers.contentType = ContentType.json;
      // Checks if the request is connected to a function
      if (routes.containsKey(req.method + req.uri.path)) {
        // close only after you send!
        routes[req.method + req.uri.path](req);
      }
    }
  }

  get(String path, Function callback) {
    routes.putIfAbsent("GET" + path, () => callback);
  }

  post(String path, Function callback) {
    routes.putIfAbsent("POST" + path, () => callback);
  }
}
